package com.kuyuntech.cofarcooking.device.sdk.devmode.core;

import com.kuyuntech.cofarcooking.device.sdk.constant.core.DevStatus;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.MotorDirections;
import com.kuyuntech.cofarcooking.device.sdk.constant.core.WorkModes;
import com.kuyuntech.cofarcooking.device.sdk.eventbus.core.DevInfo;
import com.kuyuntech.cofarcooking.device.sdk.util.core.CofarSDK;

import java.util.TimerTask;

public class SlowCooking010D extends BaseDevMode {

    private Long currentSec = 0l;

    private Thread thread;

    private boolean pasue = false;

    private boolean stop = false;

    private boolean autoPasue = false;

    private  byte isMotorGear = 0;

    private  boolean isMotorType = false;

    public SlowCooking010D() {

        this.setMode(WorkModes.SLOW_COOKING);


        //时间
        this.setMinTime(10 * 60);
        this.setMaxTime(90 * 60);
        this.setDefaultTime(60 * 60);
        this.setTimeChange(true);

        //电机
        this.setDefaultMotorGear(1);
        this.setMaxMotorGear(3);
        this.setMinMotorGear(1);
        this.setMotorGearChange(true);
        this.setMotorDirectionChange(true);
        this.setMotorDirection(MotorDirections.FORWARD);

        //温度
        this.setDefaultTemp(100);
        this.setMinTemp(60);
        this.setMaxTemp(100);

        this.setDiyCountDown(true);

    }


    @Override
    public void start() {
        currentSec = 0L;
        CofarSDK.startNative();
        this.stop = false;

    }


    @Override
    public void onCountDown(TimerTask timer) {

        if (!pasue && DevStatus.PAUSE == CofarSDK.devInfo().getStatus()) {
            if (!autoPasue) {
                return;
            }
        }

        if (pasue) {
            return;
        }

        DevInfo devInfo = CofarSDK.devInfo();


        if (devInfo.getRemainTime() <= 0 && devInfo.getMode().isCountDown()) {
            CofarSDK.stop();
            timer.cancel();
            return;
        }


        if (stop) {
            CofarSDK.stop();
            timer.cancel();
            return;
        }

        devInfo.setRemainTime((short) (devInfo.getRemainTime() - 1));

        if (((currentSec / 5) % 6) == 1) {
            autoPasue=true;
            CofarSDK.pauseNatvie();
        }

        if (((currentSec / 5) % 6) == 0) {
            autoPasue=false;
            CofarSDK.resumeNavtive();
        }


//        if (((currentSec / 5) % 6) == 1) {
//            autoPasue=true;
////            if (isMotorType){
////                CofarSDK.cfgMotorGearNative((byte) 0);
////                isMotorType = false;
////            }
//            CofarSDK.pauseNatvie();
//
//
//        }
//
//        if (((currentSec / 5) % 6) == 0) {
//            autoPasue=false;
//            CofarSDK.resumeNavtive();
//
////            if (!isMotorType){
////                isMotorGear = CofarSDK.devInfo().getMotorGearBuffer();
////                CofarSDK.cfgMotorGearNative(isMotorGear);
////                isMotorType = true;
////            }
//        }


        currentSec++;

    }

    @Override
    public void pause() {
        this.pasue = true;
        CofarSDK.pauseNatvie();
    }

    @Override
    public void resume() {
        this.pasue = false;
        CofarSDK.resumeNavtive();
    }

    @Override
    public void stop() {
        this.stop = true;
        CofarSDK.stopNative();
        super.stop();
    }


}
